# 使用Nginx将服务器目录、文件共享出来
## Nginx配置

```
http {
	
	server_token off； #关闭版本信息
	
	server {
		listen 80;
		listen [::]:80;
		server_name localhost;
		
		location / {
			alias /data/fileweb/;       #共享目录
			autoindex on;               #开启目录索引功能
			autoindex_exact_size off;   #显示文件大小
			autoindex_localtime on;     #显示文件时间
			charset utf-8;
		}
		
	}

}
```